package crystalpalace.coff;

import crystalpalace.export.*;
import crystalpalace.util.*;
import java.util.*;

public class COFFParser {
	protected byte[] data;
	protected COFFObject object;

	public COFFParser(byte[] data) {
		this.data = data;
	}

	public COFFParser parse() {
		ByteWalker parser = new ByteWalker(data);

		/* start reading the COFF Header */
		object = new COFFObject(parser);

		return this;
	}

	public COFFObject getObject() {
		return object;
	}

	public ExportPIC export() {
		return new ExportPIC(object);
	}

	public ExportPIC64 export64() {
		return new ExportPIC64(object);
	}

	public ExportPICO exportObject() {
		return new ExportPICO(object);
	}

	public void print() {
		System.out.println("File: \n" + object.toString());
	}

	public static void main(String args[]) {
		if (args.length == 0) {
			System.out.println("./coffparser [/path/to/file.o]");
			return;
		}

		try {
			new COFFParser(CrystalUtils.readFromFile(args[0])).parse().print();
		}
		catch (java.io.IOException ioex) {
			CrystalUtils.handleException(ioex);
		}
	}
}
